
  //  (c) Drobotenko    http://drobotenko.com
 

#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <math.h>
#include <float.h>
#include <iostream>


int gaus_ostatok;
double  gaus_minved,gaus_deter;


/////////////  template version of linear algebra  ////////////////
/////////////////////////////////////////
extern int gaus_ostatok;
extern double  gaus_minved,gaus_deter;
#ifndef  ASSERT
#define ASSERT(T) if(!(T)){__asm int 03\
                                       };
#
//#undef  ASSERT
//#define ASSERT(T) 
#endif
inline double _NaN()
{  unsigned long nan[2]={0xffffffff, 0x7fffffff};
   return *( double* )nan;
}
/*
inline int _isnan(double d)
{  int zr[2]={0,0};
   d-=d;//!!!!!!!
   ((float&)(zr[0]))= float(d*.0);
   return zr[0]||zr[1];
}
*/
template <class A>
 inline int dimA(A   &a){ return sizeof(a)/sizeof(a[0]);}
template <class A>
 inline int dimB(A   &a){ return sizeof(a[0])/sizeof(a[0][0]);}
template <>
 inline int dimA( double  *&){ return 1<<(sizeof(void*)*8-2);}

// typeof 
template <int> struct id_2_type {};
#define REG_TYPE(R,N) template <> struct id_2_type<N> { typedef R T; }; char (& get_type_id(R ))[N];
#define GET_TYPE(v) id_2_type<sizeof(get_type_id(v))>::T

REG_TYPE(int,__LINE__);
REG_TYPE(float,__LINE__);
REG_TYPE(double,__LINE__);

struct DblBase
{  typedef double return_t;
};


struct CmplxBase
{  typedef class complex return_t;
   //double fabs (class complex &c){ return fabs(((double const(&)[2])c)[0])+fabs(((double const(&)[2])c)[1]);}
};
//REG(complex,__LINE__);

template <class BASE= DblBase>
struct LaT:public BASE
{  template <typename T> inline static T min(T const &a,T const b){return a<b?a:b;}
   template <typename T> inline static T max(T const &a,T const b){return a>b?a:b;}
  

   template <class DMat>
   inline static void simmetric(DMat &m)
   { int RAZM=dimA(m);ASSERT(RAZM==dimB(m));
     for(int j=0;j<RAZM;j++) for(int k=j+1;k<RAZM;k++)
       m[j][k]=m[k][j]=(m[j][k]+m[k][j])/2;
   }

   template <class A,class B,class C>
   inline static  double form(A  &a,B  &m,C  &b)
   { return_t r=0.;
     int row=min(dimA(a), dimA(m))
        ,col=min(dimB(m), dimA(b));

     for(int j=0;j<row;j++)for(int k=0;k<col;k++)
       r+=a[j]*m[j][k]*b[k];
     return r;
   }
   template <class A,class B,class C>
   inline static int matvec(A  &_rez, B  &matr,C  &vec)
   { int row=min(dimA(_rez), dimA(matr))
        ,col=min(dimB(matr), dimA(vec))
        ,exact=  dimA(_rez)==dimA(matr)
               &&dimB(matr)==dimA(vec)  ;
     int r,k;     
     typedef GET_TYPE(_rez[0]+matr[0][0]+vec[0]) CT;
     CT *rez=(CT *)alloca(row*sizeof(CT)); 
     for(r=0;r<row;r++)
     { rez[r]=0;
       for(k=0;k<col;k++)
         rez[r]+=matr[r][k]*vec[k];
     }
     for(k=row;k--;)
      _rez[k]=rez[k];
     return exact;  
   }
   template <class C,class A,class B>
   inline static  int matmat(C &c, A &a,B &b)
   { int  row=min(dimA(c), dimA(a))
         ,rc =min(dimB(a), dimA(b))
         ,col=min(dimB(c), dimB(b));
     int exact=   dimA(c)==dimA(a)
                &&dimB(a)==dimA(b)
                &&dimB(c)==dimB(b);  

     typedef GET_TYPE(c[0][0]+a[0][0]+b[0][0]) CT;
     CT *mc=(CT *)alloca(sizeof(CT)*row*col);

     int r,k,j0;
     for(r=row;r--;) 
     for(k=col;k--;)
     for(mc[r *col+ k]=0,j0=rc;j0--;)
         mc[r *col+ k]+=a[r][j0]*b[j0][k];
     for(r=row;r--;) 
     for(k=col;k--;)
         c[r][k]=mc[r *col+ k];
     return exact;
   }

   template <class C,class A,class B>
   inline static  void gaus(C&  r,A& _m,B&  _v)
     {
       int const N=dimA(_m);
       ASSERT(dimA(r)==N && N==dimA(_v))
       typedef GET_TYPE(r[0]+_m[0][0]+_v[0]) CT;
       CT *m=(CT *)alloca(sizeof(CT)*N*N)
         ,*v=(CT *)alloca(sizeof(CT)*N);
       int *num= (int*)alloca(sizeof(int)*N);

       


       int j,jj,k;

       for(j=N;j--;)
          num[j]=j,v[j]=_v[j];
       for(j=N;j--;)for(k=N;k--;)
          m[j*N+k]=_m[j][k];

       int jmax,kmax;
       register  double vmax=-1,aa;
       CT t;
       for(j=N;j--;) for(k=N;k--;)
       if(vmax<(t=fabs(m[(j )*N+( k)])))
          vmax=t,jmax=j,kmax=k;

       gaus_ostatok=N;
       gaus_minved=vmax; gaus_deter=vmax;
       if(vmax<1e-99)
         goto final_;
       gaus_ostatok--;

       for(j=N;j--;)
          t=m[(j )*N+( kmax)],m[(j )*N+( kmax)]=m[(j )*N+( 0)],m[(j )*N+( 0)]=t;
       for(k=N;k--;)
           t=m[(jmax )*N+( k)],m[(jmax )*N+( k)]=m[(0 )*N+( k)],m[(0 )*N+( k)]=t;
       t=v[jmax],v[jmax]=v[0],v[0]=t;
       num[0]=kmax;num[kmax]=0;

       for(j=0;j<N-1;j++)
       {  vmax=-1;
       
          for(jj=j+1;jj<N;jj++)
          { double t=m[(jj )*N+( j)] / m[(j )*N+( j)];
            for(k=j+1;k<N;k++)
             if(vmax<(aa=fabs(m[(jj )*N+( k)]-=m[(j )*N+( k)]*t)))
                vmax=aa,jmax=jj,kmax=k;
             v[jj]-=v[j]*t;
          }
         
          if(gaus_minved>vmax)
            gaus_minved=vmax;
          gaus_deter*=m[(jmax )*N+( kmax)];
          if(vmax<1e-99)
            goto final_;
          gaus_ostatok--;

          for(jj=N;jj--;)
            t=m[(jj )*N+( kmax)],m[(jj )*N+( kmax)]=m[(jj )*N+( j+1)],m[(jj )*N+( j+1)]=t;
          for(jj=N;jj-->j;)
            t=m[(jmax )*N+( jj)],m[(jmax )*N+( jj)]=m[(j+1 )*N+( jj)],m[(j+1 )*N+( jj)]=t;
          t=v[j+1];v[j+1]=v[jmax];v[jmax]=t;
          jj=num[j+1];num[j+1]=num[kmax];num[kmax]=jj;
       }
       final_:
       int NF=N-gaus_ostatok; 
       for(j=NF;j--;)
       {  CT s=v[j];
          for(k=j+1;k<NF;k++)
            s-=m[(j )*N+( k)]*m[(NF-1 )*N+( k)];
         m[(NF-1 )*N+( j)]=s/m[(j )*N+( j)];
       }
       for(j=NF;j--;)
          r[num[j]]=m[(NF-1 )*N+( j)];
       for(j=N;j-->NF;)
          r[num[j]]=_NaN();
     }
     template <class DMat>
     inline static  void  invers(DMat &m)
     { 
       typedef GET_TYPE(m[0][0]) CT;

       int N= dimA(m);
       int *rn=(int*)alloca((sizeof(int))*N),*cn=(int*)alloca((sizeof(int))*N);
       //int rn[N],cn[N];

       int j,k;   

       for(j=N;j--;)
         rn[j]=cn[j]=j;
       gaus_minved=1e99;
       gaus_deter=1;
       for(gaus_ostatok=N;gaus_ostatok;gaus_ostatok--)
       {  int jved,kved;
          CT vved,t;
          double absvv=-1;
          for(j=N;j--;)
          {  if(~rn[j])
             for(k=N;k--;)
               if(~cn[k])
               if(absvv<fabs(m[j][k]))
                  absvv=fabs(m[j][k]),jved=j,kved=k;
          }
          if(gaus_minved>absvv)
             gaus_minved=absvv;
          gaus_deter*=m[jved][kved];
          if(absvv<1e-99)
          {  for(j=N;j--;)
             {  if(~rn[j]) for(k=N;k--;)
                  m[j][k]=_NaN();
                if(~cn[j]) for(k=N;k--;)
                  m[k][j]=_NaN();
             }
             return;
          }
          int jt=rn[jved],kt=cn[kved];
          for(j=N;j--;)
              t=m[kt][j],m[kt][j]=m[jved][j],m[jved][j]=t;
          for(j=N;j--;)
              t=m[j][jt],m[j][jt]=m[j][kved],m[j][kved]=t;

          rn[jved]=rn[kt];
          cn[kved]=cn[jt];
          rn[kt]=cn[jt]=-1;

          vved=m[kt][jt];   m[kt][jt]=1;
          for(j=N;j--;)
          {  if(j==kt)
               continue;
             CT mul=m[j][jt]/vved;
             m[j][jt]=0;
             for(k=N;k--;)
               m[j][k]-=m[kt][k]*mul;
          }
          for(k=N;k--;)
              m[kt][k]/=vved;
       }
     }    

};

#define FOR(J,V,CODE)     {for(int J=V;J--;){CODE }}
#define FOR_M(J,K,V,CODE) {for(int J=dimA(V);J--;)for(int K=dimB(V);K--;){CODE }}
/////////////////////////////////////////



typedef LaT<> Lad;


struct MyMatrix
{  double data[3][3];
   double* operator[](int i){ return data[i];}
};
//      
template <>
 inline int dimA(MyMatrix   &a){ return 3;}
template <>
 inline int dimB(MyMatrix   &a){ return 3;}



void main()
{    
    double a[5]={1,2,3,4,5}
           ,m[4][3]=
               {{10,   0,.1}
               ,{.9, 100, 0}
               ,{0,0,1000}
               ,{.7,.7,.7}
               }
            ,b[2]={1,1};

       
     double d=Lad::form(a,m,b);
     int ia[5]={1,2,3,4,5}
      ,im[3][3]=
                {{10, 0,11}
               ,{9, 20, 0}
               ,{0, 0, 40}
               };
     
     double di=Lad::form(ia,m,b);
     Lad::matvec(a,m,b);
     Lad::matvec(ia,m,b);
     Lad::matmat(m,im,m);

     double d3[3]={1,2,3}
      ,r3[3]
      ,t3[3],testm[3][3]
      ,dm[3][3]=
                {{10, .7,11}
               ,{9, 20, 4.9}
               ,{21, 11.5, 44}
               }
               ;

     Lad::gaus(r3, dm,d3);
     Lad::matvec(t3, dm,r3);
     FOR(j,dimA(t3), t3[j]-=d3[j]; ) // t3=ZERO !!!

     FOR_M(j,k,dm,  testm[j][k]=dm[j][k]; )
     Lad::invers(testm);
     Lad::matmat(testm,testm,dm);  // test==1 !!!!

     //   ,       
     MyMatrix mmm=
     { {{10, .7,11}
        ,{9, 20, 4.9}
        ,{21, 11.5, 44}
        }
     };
     Lad::invers(mmm);


     {
     #define R 250
     //       
     // 1     
    
     double va[R],vb[R], vc[R],vd[R],   mm[R][R] ;

     for(int j=R;j--;)
     for(int k=R;k--;)
      va[k]=sin(k+.2),vb[j]=cos(j+.1)+rand()/1e6,mm[j][k]=cos(j*1.)+j*.05*sin(k*1.)+k+atan(sin(k*1.)+j)+rand()/1e4;
     
     Lad::gaus(vc,   mm,va);
     Lad::matvec(vd, mm,vc);
     FOR(j,dimA(vd), vd[j]-=va[j]; ) // vd=0
     __asm nop
    }



     __asm nop

     


}

